Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/plots_histo_jiri
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/plots_histo_jiri	(revision 1965)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/plots_histo_jiri	(revision 2009)
@@ -4,5 +4,5 @@
 #PREFIX=../scripts/tests/i3d/vsposp_typical
 #PREFIX=../scripts/tests/gi/room_with_sphere_tess-5
-PREFIX=./vienna_cropped_gi-35MB
+PREFIX=./histogram
 PROGRAM=../../shared/EvalStats/Release/EvalStats.exe
 
@@ -16,10 +16,13 @@
 SAMPLES=160000000
 
-FILES="$PREFIX-sequential-50000-true-00001-00060-histo-pvs.log \
-	$PREFIX-gradient-full-00001-00060-histo-pvs.log"
+#FILES="osp-1e5-i-mixed-b1-n4c.hlog osp-1e5-r-reference-global.hlog osp-1e5-r-reference.hlog"
+FILES="osp-1e5-i-mixed-b1-n4c.hlog"
 
 $COMMAND2 boxes Pvs VolumeDif $FILES
 ./showplot $PREFIX-grad-h-$SAMPLES-pvs_volume
 
+$COMMAND2 boxes Pvs ViewCellsDif $FILES
+./showplot $PREFIX-grad-h-$SAMPLES-pvs_viewcells
+
 
 rm $PREFIX-*tmpplot*
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_histo_plot
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_histo_plot	(revision 1965)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_histo_plot	(revision 2009)
@@ -20,7 +20,7 @@
 echo set ylabel \"$3\" >> $FILE
 #echo set yrange \[0:100\] >> $FILE
-echo set xrange \[0:200000\] >> $FILE
+#echo set xrange \[0:200000\] >> $FILE
 
-echo set boxwidth 3000.0 >> $FILE
+#echo set boxwidth 300.0 >> $FILE
 echo set style fill >> $FILE
 
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling	(revision 1965)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling	(revision 2009)
@@ -1,10 +1,7 @@
 #!/bin/sh
 
-PREFIX=osp-rss
-#PREFIX=atlanta2-rss9
-#PREFIX=vienna-rss8
-#PREFIX=atlanta-e
-#PREFIX=wien-e
-#PREFIX=random-e
+#PREFIX=osp-rss-single
+PREFIX=osp-pompeii3-1e5
+#PREFIX=osp-rss2
     
 
@@ -23,6 +20,21 @@
 
 FILES="`ls $PREFIX*.log`"
-#FILES="../../src/stats.log"
-#FILES="../../src/stats.log"
+
+#FILES="osp-rss-single2g-1e5-i-mixed-b1-n7-f4.log"
+#FILES="osp-rss2-1e5-i-mixed-b1-n4c.log osp-rss2-1e5-r-reference.log osp2-1e5-r-reference.log osp-1e5-i-mixed-b1-n4c.log osp-1e5-i-mixed-b1-n4d.log osp-1e5-i-mixed-b1-n4e.log osp-1e5-i-mixed-b1-n4f.log osp-1e5-i-mixed-b1-n4g.log"
+
+
+################################
+# for the SIGGRAPH PAPER!!!!
+#FILES="osp-rss2-1e5-i-mixed-b1-n4c.log osp-rss2-1e5-r-reference-global.log osp2-1e5-r-reference.log"
+
+#FILES="osp-pompeii3-1e5-i-mixed-b1-n4e.log osp-pompeii3-1e5-r-reference-global.log osp-pompeii3-1e5-r-reference.log"
+################################
+
+ 
+#FILES="osp-rss2-1e5-i-mixed-b1-n4c.log osp-rss2-1e5-r-reference-global.log"
+#FILES="osp-rss2-1e5-i-mixed-b1-n4c.log osp-rss2-1e5-r-reference.log"
+#FILES="osp-rss2-1e5-i-mixed-b1-n4c.log osp-rss2-1e5-r-reference.log osp-rss2-1e5-r-reference-global.log"
+#FILES="../../src/stats.log n1/stats2.log"
 #FILES="soda5-rss4-i-combined-b3.log soda5-rss4-i-combined-update-b3.log soda5-rss4-r-spatial-based-b3.log soda5-rss4-r-object-based-b3.log ../../src/stats.log"
 #FILES="atlanta-50.log atlanta-new-10.log"
@@ -67,9 +79,36 @@
 ./showplot $PREFIX-avgpvs
 
+$COMMAND2 $STYLE TotalSamples AVG_ENTRIES_PVS $FILES
+./showplot $PREFIX-avgpvse
+
+
+# $COMMAND2 $STYLE RssSamples AVG_PVS $FILES
+# ./showplot $PREFIX-avgpvs-rss
+
+# $COMMAND3 $STYLE RssSamples AVG_REL_PVS_INCREASE $FILES
+# ./showplot $PREFIX-avgrelpvsincrease
+
+# $COMMAND2 $STYLE TotalSamples AVG_VIEWCELLS_PER_RAY $FILES
+# ./showplot $PREFIX-avgviewcellsperray
+
+# $COMMAND2 $STYLE TotalSamples CONTRIBUTING_RAYS $FILES
+# ./showplot $PREFIX-contributingrays
+
+# #$COMMAND3 $STYLE RssSamples DEV_REL_PVS_INCREASE $FILES
+# #./showplot $PREFIX-devrelpvsincrease
+
 $COMMAND2 $STYLE Time AVG_PVS $FILES
 ./showplot $PREFIX-avgpvstime
 
+# $COMMAND2 $STYLE TotalSamples AVG_FILTERED_PVS $FILES
+# ./showplot $PREFIX-avgfpvs
 
-$COMMAND2 $STYLE TotalSamples AVG_FILTERED_PVS $FILES
-./showplot $PREFIX-avgfilteredpvs
+# $COMMAND2 $STYLE TotalSamples AVG_FILTERED_ENTRIES_PVS $FILES
+# ./showplot $PREFIX-avgfpvse
 
+
+# # $COMMAND2 $STYLE TotalSamples AVG_FILTER_RADIUS $FILES
+# # ./showplot $PREFIX-avgfradius
+
+# # $COMMAND2 $STYLE TotalSamples AVG_FILTER_RATIO $FILES
+# # ./showplot $PREFIX-avgfratio
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2	(revision 2009)
@@ -1,4 +1,4 @@
 #!/bin/sh
-unalias rm
+#unalias rm
 
 rm -f *.tmpplot*
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot3
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot3	(revision 1754)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot3	(revision 2009)
@@ -19,12 +19,12 @@
 echo set xlabel \"$2\" >> $FILE 
 echo set ylabel \"$3\" >> $FILE
-echo set yrange \[1:1e8\] >> $FILE
 
+#echo set yrange \[1:1e8\] >> $FILE
 #echo set boxwidth 0.4 >> $FILE
 
-echo set logscale xy >> $FILE
+echo set logscale y >> $FILE
 echo -n plot >> $FILE
 
-echo -n " " x*x*x*x*x*x*x*log\(x\)  title \"O\(k^2 log k\)\" with lines" , " >>$FILE
+#echo -n " " x*x*x*x*x*x*x*log\(x\)  title \"O\(k^2 log k\)\" with lines" , " >>$FILE
 
 PAR1=$2
@@ -46,5 +46,5 @@
     paste $i.tmpplot.x $i.tmpplot.y > $i.tmpplot ;
     if test $i != $1 ; then echo -n ", ">>$FILE; fi
-    echo -n " "\"$i.tmpplot\"  title \"$NAME\" with $STYLE" " pt $pt >>$FILE ;
+    echo -n " "\"$i.tmpplot\"  title \"$NAME\" with $STYLE" " >>$FILE ;
     YPLOT="$YPLOT $i.tmpplot.y";
     case $NAME in
@@ -58,6 +58,6 @@
     let pt=$pt+1;
 done ;
-echo -n ", " 1.2*x*x*log\(x\)  title \"O\(k^2 log k\)\" with lines lt 2 " , " >>$FILE
-echo -n " " 0.05*x*log\(x\)  title \"O\(k log k\)\" with lines lt 3 " " >>$FILE
+#echo -n ", " 1.2*x*x*log\(x\)  title \"O\(k^2 log k\)\" with lines lt 2 " , " >>$FILE
+#echo -n " " 0.05*x*log\(x\)  title \"O\(k log k\)\" with lines lt 3 " " >>$FILE
 echo >> $FILE
 paste $1.tmpplot.x $YPLOT | grep -v "#"