Index: GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.7.1.sln
===================================================================
--- GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.7.1.sln	(revision 2026)
+++ GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.7.1.sln	(revision 2026)
@@ -0,0 +1,91 @@
+Microsoft Visual Studio Solution File, Format Version 8.00
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule", "..\..\IllumModule\IllumModule\scripts\illummodule.7.10.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule_Ogre", "..\..\IllumModule\OgreIllumModule\scripts\OgreIllumModule.7.10.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA95}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsRaytraceDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsRaytraceDemo\scripts\GameToolsRaytraceDemo.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "HPSDEMO", "..\..\..\..\App\Demos\Illum\Ogre\src\HierarchicalSystem\scripts\HierarchicalSystem.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "PRMDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\PRMDemo\scripts\PRMDemo.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsParticleDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\scripts\GameToolsParticleDemo.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "CausticTest", "..\..\..\..\App\Demos\Illum\Ogre\src\CausticTest\scripts\CausticTest.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "DiffuseTest", "..\..\..\..\App\Demos\Illum\Ogre\src\DiffuseTest\scripts\DiffuseTest.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ToneMapDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsToneMapDemo\scripts\GameToolsToneMapDemo.7.10.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
+	ProjectSection(ProjectDependencies) = postProject
+		{109F610E-9B23-4D05-819E-A7F27A42AA95} = {109F610E-9B23-4D05-819E-A7F27A42AA95}
+	EndProjectSection
+EndProject
+Global
+	GlobalSection(SolutionConfiguration) = preSolution
+		Debug = Debug
+		Release = Release
+	EndGlobalSection
+	GlobalSection(ProjectConfiguration) = postSolution
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA95}.Debug.ActiveCfg = Debug|Win32
+		{109F610E-9B23-4D05-819E-A7F27A42AA95}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
+		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(ExtensibilityGlobals) = postSolution
+	EndGlobalSection
+	GlobalSection(ExtensibilityAddIns) = postSolution
+	EndGlobalSection
+EndGlobal
Index: GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln.old
===================================================================
--- GTP/trunk/Lib/Illum/shared/scripts/GTPIllumination.sln.old	(revision 1689)
+++ 	(revision )
@@ -1,94 +1,0 @@
-Microsoft Visual Studio Solution File, Format Version 8.00
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule", "..\..\IllumModule\IllumModule\scripts\illummodule.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IllumModule_Ogre", "..\..\IllumModule\OgreIllumModule\scripts\OgreIllumModule.vcproj", "{109F610E-9B23-4D05-819E-A7F27A42AA94}"
-	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsRaytraceDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsRaytraceDemo\scripts\GameToolsRaytraceDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "HPSDEMO", "..\..\..\..\App\Demos\Illum\Ogre\src\HierarchicalSystem\scripts\HierarchicalSystem.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "PRMDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\PRMDemo\scripts\PRMDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GameToolsParticleDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsParticleDemo\scripts\GameToolsParticleDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-		{109F610E-9B23-4D05-819E-A7F27A42AA94} = {109F610E-9B23-4D05-819E-A7F27A42AA94}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "CausticTest", "..\..\..\..\App\Demos\Illum\Ogre\src\CausticTest\scripts\CausticTest.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "DiffuseTest", "..\..\..\..\App\Demos\Illum\Ogre\src\DiffuseTest\scripts\DiffuseTest.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ToneMapDemo", "..\..\..\..\App\Demos\Illum\Ogre\src\GameToolsToneMapDemo\scripts\GameToolsToneMapDemo.vcproj", "{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Global
-	GlobalSection(SolutionConfiguration) = preSolution
-		Debug = Debug
-		Release = Release
-	EndGlobalSection
-	GlobalSection(ProjectConfiguration) = postSolution
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.ActiveCfg = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Debug.Build.0 = Debug|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.ActiveCfg = Release|Win32
-		{109F610E-9B23-4D05-819E-A7F27A42AA94}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.ActiveCfg = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Debug.Build.0 = Debug|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.ActiveCfg = Release|Win32
-		{09F9E809-02CF-4926-8203-2B9C02FBD916}.Release.Build.0 = Release|Win32
-	EndGlobalSection
-	GlobalSection(ExtensibilityGlobals) = postSolution
-	EndGlobalSection
-	GlobalSection(ExtensibilityAddIns) = postSolution
-	EndGlobalSection
-EndGlobal